<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Zip_v3 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('user_login');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START 
		// ################################################################ 
		$this->load->model('Recheck_access5');
		$var_access_status = $this->Recheck_access5->reset_access5();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // // // // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // // // // echo "!! must write other functions code for funciton $callfunction";
		}
		////// // var_dump($_POST);
	}	

	public function make_zip($sourcePath, $zipFilePath) {
		if (!extension_loaded('zip') || !file_exists($sourcePath)) {
			return false;
		}

		$zip = new ZipArchive();
		if (!$zip->open($zipFilePath, ZipArchive::CREATE | ZipArchive::OVERWRITE)) {
			return false;
		}

		$sourcePath = realpath($sourcePath);
		$sourcePathLength = strlen($sourcePath);

		$addToZip = function($path) use ($zip, $sourcePath, $sourcePathLength, &$addToZip) {
			if (is_dir($path)) {
				$files = scandir($path);
				foreach ($files as $file) {
					if ($file === '.' || $file === '..') continue;
					$addToZip($path . DIRECTORY_SEPARATOR . $file);
				}
			} elseif (is_file($path)) {
				$localPath = substr($path, $sourcePathLength + 1); // relative path
				$zip->addFile($path, $localPath);
			}
		};

		if (is_dir($sourcePath)) {
			$addToZip($sourcePath);
		} else if (is_file($sourcePath)) {
			$zip->addFile($sourcePath, basename($sourcePath));
		}

		return $zip->close();
	}



	public function zip_file_upload() {
		
		$_POST['update_error'] = ""; 
		$var_date_time = date("Y/m/d H:i:s");
		
		$_POST['zip_notes_release'] = "<b><u>Domain:</u>{$_POST['zip_website']} <u>Action:</u>{$_POST['zip_action']}</b> at <u>$var_date_time</u>"; 
		$full_path = ""; 
		$targetDir = str_replace('/churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']); 
		$targetPath = $targetDir . "/a_zip_sprints/"; 

		// ######################################################################
		// ### COPY ZIP PACKAGES - RUNNING - SWITCHES ON PROFILE SELECT UPLOAD 
		// ######################################################################

		if ($_FILES['zip_file_url_packet']['name'] and strpos($_POST['zip_action'], "Upload") !== false) { // IF FILE LOADED AND UPLOAD SELECTED 
		
			$targetPath = "/home/!!!!/churchofjesus.live/files_biz_skills/"; // correct path for infinity 
			$targetPath = $_SERVER['DOCUMENT_ROOT'] . "/zip_packets/"; 
			
			$targetPath = $_SERVER['DOCUMENT_ROOT'] . "/zip_packets/"; ### prev line better - just testing local files for copy 
			$targetPath = str_replace('/churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . "/a_zip_sprints/"; // ### upload works / copy does not 
			
			$varurlpath = "https://churchofjesus.live/zip_packets/"; 
			$upload=$_FILES['zip_file_url_packet']['name']; 
			$ext=end(explode('.',$upload)); 
			
			$config['allowed_types'] = array('jpg','jpeg', 'png', 'wmf', 'php', 'gzip', 'zip');
			if(in_array($ext,$config['allowed_types'])) {
				// $upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
				$vardate = date("Y-m-d-H-m-s"); 
				$targetFile = $_POST['zip_website'] . "_" . $_POST['zip_name'] . "_" . $vardate . "." . $ext; 
				if (1==1 or is_dir($targetPath)and is_writable($targetPath)) { 
					if (move_uploaded_file($_FILES['zip_file_url_packet']['tmp_name'], $targetPath . $targetFile)) { 
						// ### THIS IS NOW UNREACHABLE AS AN URL - BLOCKING HACKS OR ACCESS TO PATCHES 
						$full_path = $varurlpath . $targetFile; // ### THIS IS USED FOR VIDS AND PICS 
						$full_path = $targetPath . $targetFile; // ### FOR ZIP PACKAGES 
						$_POST['zip_notes_release'] .= "<br>The file <b>was</b> uploaded to $targetPath"; 
					} else {
						$_POST['update_error'] = "Cannot move package to target $targetPath for file $targetFile";
					}
				} else {
					// $err = "The path target or dir $targetPath or NOT WRITABLE";
					$_POST['update_error'] = "The path target or dir $targetPath or NOT WRITABLE";
				}
			} else {
				$_POST['update_error'] = "The file must be 'jpg','jpeg', 'png', 'wmf', 'php', 'gzip' or 'zip' zip, php or image file types";
			}
			
			if ($_POST['update_error'] != "") { // ### LOG ANY ERROR 
				$_POST['zip_notes_release'] .= "<br>" . $_POST['update_error'];
			}
		}
	
		// ###################################################################### 
		// ### A LOAD ZIP FILES - PRIORITY FOR PACKAGES - /// WORKS /// - SWITCHES ON PROFILE SELECT INSTALL 
		// ### B BEST OPTION GET RUNNING FROM home/cpanel_domain/a_zip_sprints /// WORKS - IS RELATIVE TO ANY SERVER /// 
		// ### C MOVE TO MULTIPLE DIRS - DONE IN ZIP CODE !!
		// ### D PLACE BETA MENU TO TEST NEW ENTRIES LIKE CONTROLLER_V+1 ## NEXT ALLOW UPDATE OF MENUS FOR EXTRA ENTRY OR CHANGE ENTRY ## 
		// ######################################################################

		$target_copy_dir = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; 
		// echo "<br><b>!! THE target_copy_dir = $target_copy_dir</b> ROOT MUST THEN BE BLANK "; 
		// echo "<br><b>!! THE target_copy_dir = $target_copy_dir</b> "; 

		if (($ext == "zip" or $ext == "zgip") and strpos($_POST['zip_action'], "Install") !== false and $full_path != "") {
			// ### NOTE THAT CAN DO application folder with /controllers / views /models - even /images above it 

			// $zip = new ZipArchive;
			$file = 'file.zip'; 
			$file = $targetPath . $targetFile; 

			// get the absolute path to $file 
			$path = pathinfo(realpath($file), PATHINFO_DIRNAME);
			$path = $targetPath;
			
			// ###################################################################### 
			// ### OLD TEST WAY - NOT USED ANYMORE 
			// ######################################################################
			if ($_POST['zip_target_drop'] == "application/controllers/" or $_POST['zip_target_drop'] == "application/aload_test/") { 

				// #### MUST ARCHIVE ZIP AFTER THIS #### RENAMING OF MATCHING FILES IS KEY 
				$targetPath = $_SERVER['DOCUMENT_ROOT'] . "/" . $_POST['zip_target_drop']; ### TARGET SELECTED BY ZIP DRIVER 
				// // // echo "<br>USING VARIABLE DIR TARGET $targetPath FOR post target {$_POST['zip_target_drop']} "; 
				
			} else { 
			
				$targetPath = $_SERVER['DOCUMENT_ROOT'] . "/application/aload_test/"; ### prev line better - just testing local files for copy 
				
			} 
			
			// ###################################################################### 
			// ### NEW WAY THIS IS NOW USED 
			// ### TO GET MORE OPTIONS FOR TARGET - JUST ADD MORE OPTIONS INTO THIS DIRECTORY 
			// ### / AS A ROOT FOR THAT WEB SITE CAN BE NEEDED TO DROP INTO VIDEO AND IMAGE DIRS ALSO 
			// ###################################################################### 
			
			$targetPath = $_SERVER['DOCUMENT_ROOT'] . "/" . $_POST['zip_target_drop']; ### TARGET SELECTED BY ZIP DRIVER 
			
			// ###################################################### 
			// ### BEST PATH AS WORKS FOR MULTIPLE DOMAIN OPTIONS 
			// ###################################################### 
			if ($_POST['zip_target_drop'] != "/") {
				$targetPath = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; 
			} else { 
				$targetPath = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . $_POST['zip_target_drop']; //## HERE THE COPY IS TO ROOT 
			} 
			
			
			$path = $targetPath;
			echo "<br>!! cc path is $path ";
			// ### $_POST['full_dir_list'] = $_POST['full_dir_root_base'] . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; 
			// ### MORE WORK TO MAKE PATH GENERIC TO ANY SERVER ; 
			$path = $_POST['full_dir_list']; 
			echo "<br>!! dd NEW path is $path"; 

			$zip = new ZipArchive;
			$res = $zip->open($file);
			
			if ($res === TRUE) {

			  // extract it to the path we determined above
			  $zip->extractTo($path);
			  $zip->close();
			  $_POST['zip_notes_release'] .= "<br>The zip <b>was</b> extracted to $path";
			  
			} else {

			  $_POST['zip_notes_release'] .= "<br>The zip file was <b>not</b> extracted to $path";
			  
			}
				

		// ######################################################################
		// ### B QUOTE USELESS AS ZIP IS FAR MORE POWERFUL WITH MULTIPLE DIRS 
		// ######################################################################

		} elseif ($_POST['zip_action'] == "Upload and Install" and $full_path != "") { 
				// $targetPath . $targetFile; // ### FOR ZIP PACKAGES 
				// ### TO WORK MAY NEED TO ZIP THEM ALL - TO KNOW FULL NAMES AND DIRECTORIES 
				$src_copy_full = $full_path; 
				$target_copy_dir = str_replace('/churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/controllers/"; 
				$target_copy_dir = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/logs/"; 
				$target_copy_dir = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/" . $_POST['zip_target_drop'];

				// ###################################################### 
				// ### BEST PATH AS WORKS FOR MULTIPLE DOMAIN OPTIONS 
				// ### TEST ON THIS DIR SETTING 
				// ###################################################### 
				if ($_POST['zip_target_drop'] != "/") { 
					$target_copy_dir = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; 
				} else { 
					$target_copy_dir = str_replace('churchofjesus.live','',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . $_POST['zip_target_drop']; //## HERE THE COPY IS TO ROOT 
				} 
				
				$target_copy_file = $_FILES['zip_file_url_packet']['name']; 
				$target_copy_full = $target_copy_dir . $target_copy_file; 

				// echo "<br>BB !! Plan to copy to $target_copy_full <br>To $target_copy_full";

				// error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE); 
				// #### // SYNTAX CORRECT - 1). GET SIMPLE COPY, MULTIPLE FILES, UNZIP 
				// #### // SYNTAX CORRECT - 2). WORK ON UNZIP FOR MORE FILES 
				if( !copy($src_copy_full, $target_copy_full) ) {
					// // // // echo "<br><b>File can't be copied! </b>"; 
					$_POST['update_error'] .= " File uploaded but cannot be copied to application folders.";
				} else { 
					// // // // echo "<br><b>File is copied! </b>"; 
				}
				error_reporting(0);
		}
		
		// // // // echo "<br>!! 77 The full path variable is $full_path ";
		return($full_path); 
		
	}
	
	public function getdirectory($directory) {
		// Initialize an empty array to store the directory and file details

		$fileList = array();

		// Open the directory
		
		if ($handle = opendir($directory)) {
			// Loop through the directory contents
			// echo "<br>!! 22 in";
			while (false !== ($entry = readdir($handle))) {
				// Skip . and .. directories
				if ($entry != '.' && $entry != '..') {
					$filePath = $directory . DIRECTORY_SEPARATOR . $entry;

					// Initialize an array to hold the file/directory details
					$entryDetails = [
						'name' => $entry,
						'type' => is_dir($filePath) ? 'directory' : 'file',
						'date_created' => date("Y-m-d H:i:s", filectime($filePath)),
						'date_modified' => date("Y-m-d H:i:s", filemtime($filePath)),
					];

					// If it's a file, add the size to the array
					if (is_file($filePath)) {
						$entryDetails['size'] = filesize($filePath);
					}

					// Add the entry details to the list
					$fileList[] = $entryDetails;
				}
			}
			// Close the directory
			closedir($handle);
		}

		usort($fileList, function($a, $b) {
			// First, compare by directory or file type (directories first)
			if ($a['type'] === 'directory' && $b['type'] !== 'directory') {
				return -1;
			}
			if ($a['type'] !== 'directory' && $b['type'] === 'directory') {
				return 1;
			}

			// Then, compare alphabetically by name
			return strcasecmp($a['name'], $b['name']);
		});
		// echo "<br>!! 99 have sorted ";
		
		return $fileList;
	}

	public function edit_pwd()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "aasys_zip_files";
		if (isset($_POST['zip_name'])) {

			// ###################################################################### 
			// ### GENERATE  THE  DIR  LIST  TO  VIEW  INTO  FILE  LIST  &  DATES ### 
			// ###################################################################### 
			
			if (1==1) { // ### BEST WAY AND WORKS FOR ANY CPANEL - UTILITY CODE MUST WORK LIKE THIS 
	
				$var_doc_root_base = str_replace("/home/","",$_SERVER['DOCUMENT_ROOT']); 
				$docroot_array = explode('/',$var_doc_root_base); 
				$var_doc_root_base = "/home/" . $docroot_array[0] . "/"; 

				if ($_POST['zip_target_drop'] != "/") { 
					$_POST['full_dir_list'] = $var_doc_root_base . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; 
				} else { 
					$_POST['full_dir_list'] = $var_doc_root_base . $_POST['zip_website'] . $_POST['zip_target_drop']; //## HERE THE COPY IS TO ROOT 
				} 
				echo "<br><b>!! 33 full dir_list using ORIG is {$_POST['full_dir_list']}</b>"; 
				
			} else { // ### OLD WAY WORKS ONLY FOR GIVEN DOMAIN 
				$var_domain_run_zip_from = "churchofjesus.live"; 
				if ($_POST['zip_target_drop'] != "/") { 
					$_POST['full_dir_list'] = str_replace($var_domain_run_zip_from,'',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; 
				} else { 
					$_POST['full_dir_list'] = str_replace($var_domain_run_zip_from,'',$_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . $_POST['zip_target_drop']; //## HERE THE COPY IS TO ROOT 
				}
				echo "<br><b>!! 44 full dir_list using ORIG is {$_POST['full_dir_list']}</b>"; 
			}
			
			if ($_POST['zip_action'] == "Create Zip") { 
				$src_copy_full = $full_path; 
				if ($_POST['zip_target_drop'] != "/") { 
					$source_dir = str_replace('churchofjesus.live', '', $_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . "/" . $_POST['zip_target_drop']; //## HERE THE COPY IS TO ROOT 
					echo "<br>!! 22 aa We are in create zip 1 - $source_dir "; 
				} else { 
					$source_dir = str_replace('churchofjesus.live', '', $_SERVER['DOCUMENT_ROOT']) . $_POST['zip_website'] . $_POST['zip_target_drop']; //## HERE THE COPY IS TO ROOT 
					echo "<br>!! 11bb We are in create zip 2 - $source_dir "; 
				} 
				echo "<br>!! 22 next must confirm that source dir is - $source_dir "; 
				echo "<br>!! 33 next must determine and create - $zip_download_dir "; 
				// $make_zip_result = make_zip($source_dir, $zip_download_dir); 
			} 
			
			// ### !!! CREATE ZIP ### 
			
			$data['filelist'] = $this->getdirectory($_POST['full_dir_list']); 
			echo "<br><b>!! 55 full dir_list using ORIG is {$_POST['full_dir_list']}</b>"; 
			// var_dump($data['filelist']); 
			
			// ### IF INACTIVE THEN CAN DELETE - LEAVE A WHILE TO ENSURE NOT NEEDED 
			if (1==2 and $_POST['delete_module'] == "Y") { 
				$data_rec = array(); 
				// ### Mark for the trash listing 
				$data_rec['pwd_trash_del'] = "Y"; 
				// $this->db->where('id', $_POST['id']);
				// $this->db->update($varmain_table, $data_rec); 
				redirect('Zip_v3/list/manage_key_lists_4');
			} 

			// ### LOAD FILE - GENERIC LOADER MUST BE FOR ANY SERVER 
			if ($_FILES['zip_file_url_packet']['name']) {
				if ($_POST['zip_liverun_archive'] != "Y" and strpos($_POST['zip_action'], "Upload") !== false) {
					$data_rec['zip_file_url_packet'] = $this->zip_file_upload();
				}
			}

			$data_rec = array(); 
			$data_rec['zip_name'] = $_POST['zip_name']; $data_rec['zip_website'] = $_POST['zip_website']; 
			$data_rec['zip_action'] = $_POST['zip_action']; 

			if ($_POST['zip_test'] == "Y") { $data_rec['zip_test'] = "Y"; } else { $data_rec['zip_test'] = "N"; } 
			if ($_POST['zip_liverun_archive'] == "Y") { $data_rec['zip_liverun_archive'] = "Y"; } else { $data_rec['zip_liverun_archive'] = "N"; } 
									
			$data_rec['zip_notes_release'] = $_POST['zip_notes_release'];
			$data_rec['zip_notes_strategy'] = $_POST['zip_notes_strategy'];
			$data_rec['zip_notes_next'] = $_POST['zip_notes_next'];
			$data_rec['zip_notes_sql'] = $_POST['zip_notes_sql'];
			$data_rec['zip_sql_tables'] = $_POST['zip_sql_tables'];
			$data_rec['zip_sql_insertrecs'] = $_POST['zip_sql_insertrecs'];
			$data_rec['zip_target_drop'] = $_POST['zip_target_drop'];

			// $data_rec['gen_pass_notes_support'] = $_POST['gen_pass_notes_support'];
			// if ($_POST['gen_pass_fav'] == "Y") {$data_rec['pass_fav'] = "Y";} else {$data_rec['pass_fav'] = "N";} 
			// if ($_POST['gen_pass_draft'] == "Y") {$data_rec['pass_draft'] = "Y";} else {$data_rec['pass_draft'] = "N";} 
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
				$xmodules_id = $_POST['id'];
			} else {
				$data_rec['zip_date'] = date('d/m/Y H:m:s'); $data_rec['zip_date_sort'] = date('Y/m/d H:m:s'); 
				$this->db->insert($varmain_table, $data_rec);
				$_POST['id'] = $this->db->insert_id();
			}
		}
		
		//### VIP SET THE parent_has_children FLAG 
		If ($_POST['return_to_list'] == "yes") {
			redirect('Zip_v3/list/manage_key_lists_4');
		} else {

			$sql = "select * from ainf_vps3_code_manager where code_group = 'zip_target_directories' order by code_name"; 
			$data['zip_target_dirs'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_vps3_code_manager where code_group = 'web_sites_live' order by code_name"; 
			$data['web_sites_live'] = $this->db->query($sql)->result_array(); 
			if ($_POST['zip_liverun_archive'] == "Y") {
				$sql = "select * from ainf_vps3_code_manager where code_group = 'zip_action' and code_name not like '%install%' order by code_name"; 
			} else {
				$sql = "select * from ainf_vps3_code_manager where code_group = 'zip_action' order by code_name"; 
			}
			$data['zip_action_list'] = $this->db->query($sql)->result_array(); 
			
			if ($_POST['id'] != 0 and $_POST['id'] != "") { // The id is always set from default meeting 
				$sql = "select * from $varmain_table where id = {$_POST['id']} ";
				$data['curr_zip'] = $this->db->query($sql)->result_array();
				$this->load->view('update_zip_v3', $data);
			} else {
				$_POST['id'] = 0;
				$this->load->view('update_zip_v3', $data);
			}
		}
	}
	
	public function list($pagename)
	{
	
		// // // // // echo "<br>!! 11 ";
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";

		$var_search = "";
		$var_mastercompid = 113;
		
		$sql = "select * from aasys_zip_files where zip_action not like '%Down%' and zip_liverun_archive not in ('Y') order by zip_date_sort desc"; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from aasys_zip_files where zip_action like '%Down%' and zip_liverun_archive not in ('Y') order by zip_date_sort desc"; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from aasys_zip_files where zip_liverun_archive in ('Y') order by zip_date_sort desc"; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 
		
		// var_dump($data['main_list_array_tab3']); 
		
		if (file_exists(base_url("views/$pagename_orig"))) 
		{ 
			$_POST['error'] = ""; 
			$this->load->view($pagename_orig, $data); 
		} else { 
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page."; 
			$this->load->view($pagename_orig, $data); 
			// $this->load->view('index', $data); 
		}
		
	}

}
	