<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Disciples4 extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type'] 
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // echo "!! must write other functions code for funciton $callfunction";
		}
	}

	public function listing($pagename)
	{
		// #### Get page name for the link 
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		$var_last_month = date('Y/m/d', strtotime('-8 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 7 DAYS
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where 
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		
		//#### NOTE WE ARE DROPPING COMPID TO ALLOW FRIENDS FROM OTHER MINISTRIES 
		$var_myid_packed = "," . $_POST['sess_userid'] . ",";
		$sql = "select * from ainf_vps3_users where my_friends like '%$var_myid_packed%' order by compid, first_name, last_name"; 
		// $data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'discipleship_type' order by code1, code_name";
		$data['discipleship_types'] = $this->db->query($sql)->result_array();

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and referred_by = {$_POST['sess_userid']} order by first_name, last_name";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and (my_mentor_1 = {$_POST['sess_userid']} or my_mentor_2 = {$_POST['sess_userid']}) order by first_name, last_name";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select userid, mobile, email, userid, first_name, last_name from ainf_vps3_users where compid = $varcompid and (team_regular_church is null or email is null or addr_suburb is null or addr_street is null) order by first_name, last_name";
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();
		
		//### NOT USED EXCEPT IN REPORT - GOOD FOR PRAYER REQUEST LISTINGS 
		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
	}

	public function attendeestatus($pagename)
	{
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 

		$var_this_yr_month =  date("Y/m"); // Get the users NOT having follow_ups 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name";
		$data['follups_left'] = $this->db->query($sql)->result_array();
		
		//### PRAYER REQUESTS 
		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort like '%$var_this_yr_month%' order by userid, request_date_sort desc";
		$data['prayer_req_new'] = $this->db->query($sql)->result_array();

		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort not like '%$var_this_yr_month%' and req_status not in ('Answered') order by userid, request_date_sort desc";
		$data['prayer_req_open'] = $this->db->query($sql)->result_array();
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.mobile, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		//### QUERIES FOR GAPS REPORT 
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		
		$var_last_month = date('Y/m/d', strtotime('-31 days')); 
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['no_followups_month'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 
		
		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where team_regular_church is null or email is null or addr_suburb is null or addr_street is null and compid = $varcompid order by first_name, last_name";
		$data['no_key_dates'] = $this->db->query($sql)->result_array();
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}		
	}

}
	
